'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽ法）
'縮小ﾏﾄﾘｯｸｽ方式採用
'分割計算の外部入出力廃止
Imports System.Drawing

Public Class FEM3NLCal4
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(240, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "構造解析計算の実行（バンドマトリックス法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(136, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(260, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'FEM3NLCal4
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "FEM3NLCal4"
        Me.Text = "FEM3NLCal4"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim Nbound As Integer       '拘束の全節点数
    Dim NBvar As Integer        '固定の変数の数
    Dim Neff As Integer         '縮小ﾏﾄﾘｯｸｽの行列数
    Dim NxF As Integer          'FEM行列分割時の1行列の変数の数

    Dim EpsMax As Single        '最大の相当歪み
    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置

    Dim Jdirect(,) As Integer   '拘束全節点の各軸方向拘束有無(0:非拘束、1:拘束）
    Dim KBfix() As Integer      '固定の変数番号
    Dim KDispMax(3) As Integer  '最大変位の節点番号
    Dim KStMax(10) As Integer   '最大応力の節点番号
    Dim Lcomp() As Integer      '全変数の縮小ﾏﾄﾘｯｸｽ変数番号
    Dim Nrest() As Integer      '拘束の全節点番号
    Dim Nw() As Integer         '各節点の共通要素数

    Dim B(,) As Double          'Bﾏﾄﾘｯｸｽ
    Dim Db(,) As Double         'DBﾏﾄﾘｯｸｽ
    Dim DispMax(3) As Single    '最大変位
    Dim Ek(,) As Double         '要素計算の２次配列
    Dim EpsG(6) As Double       '積分点の歪み
    Dim Eu() As Double          '節点変位
    Dim Eyb(,) As Single        '全要素の積分点のﾔﾝｸﾞ率
    Dim Sgaus(,) As Double      '要素計算のｶﾞｳｽ点応力
    Dim Spoint(,) As Double     '要素計算の節点応力
    Dim StMax(10) As Single     '最大応力
    Dim Tf() As Double          'FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tfx() As Single         '初期変位
    Dim Tk(,) As Double         'FEM行列
    Dim Tp(,) As Double         '節点応力累積値
    Dim Tr(20, 27) As Single    '節点応力計算ﾏﾄﾘｯｸｽ
    Dim Ua() As Double          '解の一次記憶ﾍﾞｸﾄﾙ
    Dim VBfix() As Double       '変数固定値
    Dim VBmat(,) As Double      '変数固定の行列要素値
    Dim Vdirect(,) As Double    '拘束全節点の各変位方向拘束値

    Private Sub BForceCalc()
        '拘束境界の反力計算
        Dim aa$
        Dim i, ib, id, ie, ii, ip, j, jj, k, kb, nmax As Integer
        Dim b1 As Single
        Dim buf(Ndim), tfb(Nvar), zbuf(Nvar) As Single

        aa$ = "＜節点番号、Ｆx、Ｆy、Ｆz＞"
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 拘束境界の節点反力 ＊＊")
        SwK.WriteLine(aa$)

        If KindElem = 0 Then
            nmax = 20
        End If
        kb = 0
        For ib = 1 To Nbound
            For i = 1 To Ndim
                buf(i) = 0
            Next i
            ii = Nrest(ib)
            For ie = 1 To Nelem
                k = 0
                For j = 1 To nmax
                    If NNelem(ie, j) = ii Then
                        k = j
                        Exit For
                    End If
                Next j
                If k > 0 Then
                    jj = 0
                    For j = 1 To nmax
                        ip = NNelem(ie, j)
                        i = Ndim * (Kcomp(ip) - 1)
                        For id = 1 To Ndim
                            jj = jj + 1
                            zbuf(jj) = Tf(Lcomp(i + id))
                        Next id
                    Next j
                    Call ElemMatrix3(ie, zbuf)      '要素ﾏﾄﾘｯｸｽの計算
                    For i = 2 To Nvar
                        For j = 1 To i - 1
                            Ek(i, j) = Ek(j, i)
                        Next j
                    Next i
                    For i = 1 To Nvar
                        b1 = 0
                        For j = 1 To Nvar
                            b1 = b1 + Ek(i, j) * zbuf(j)
                        Next j
                        tfb(i) = b1
                    Next i
                    j = Ndim * (k - 1)
                    For i = 1 To Ndim
                        j = j + 1
                        buf(i) = buf(i) + tfb(j)
                    Next
                End If
            Next ie
            aa$ = Str(ii)
            For i = 1 To Ndim
                If Jdirect(ib, i) = 0 Then
                    buf(i) = 0
                End If
                aa$ = aa$ + ",  " + Str(buf(i))
            Next i
            SwK.WriteLine(aa$)
        Next ib

    End Sub

    Private Sub BMatrix()
        '変位を歪に変換するﾏﾄﾘｯｸｽの計算
        Dim i, ii, isb, j, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For isb = 1 To Nstress
            For i = 1 To Nvar
                B(isb, i) = 0
            Next i
        Next isb
        For ii = 1 To nmax
            j = Ndim * (ii - 1)
            B(1, j + 1) = Dx(ii)
            B(2, j + 2) = Dy(ii)
            B(3, j + 3) = Dz(ii)
            B(4, j + 1) = Dy(ii)
            B(4, j + 2) = Dx(ii)
            B(5, j + 2) = Dz(ii)
            B(5, j + 3) = Dy(ii)
            B(6, j + 1) = Dz(ii)
            B(6, j + 3) = Dx(ii)
        Next ii

    End Sub

    Private Sub CoeffMatrix(ByVal ie As Integer, ByVal istage As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･計算区分（-1:初期応力、0:主計算、1:ｶﾞｳｽ点応力）
        Dim i, id, ig, ii, isb, j, j1, j2, j3, jg, k, kg, kkg, numg As Integer
        Dim e As Single
        Dim b1, b2, b3, dj, dv, s, t, u As Double
        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                    Call BMatrix()
                    j = ig + 3 * jg + 9 * kg - 12
                    e = Eyb(ie, j)
                    Call DMatrix(ie, e)

                    If istage < 0 Then
                        k = NumMat(ie)
                        b1 = Alpha(k)
                        If KindTemp = 0 Then
                            b2 = b1 * (TempG(numg) - TempIG(numg))
                        Else
                            b2 = b1 * (Temp(k) - TempInit(k))
                        End If
                        b3 = D(0, 0) * b2 * dv
                        For i = 1 To 20
                            k = 3 * (i - 1)
                            j1 = NPrefer(k + 1)
                            If j1 > 0 Then
                                Tf(j1) = Tf(j1) + Dx(i) * b3
                            End If
                            j2 = NPrefer(k + 2)
                            If j2 > 0 Then
                                Tf(j2) = Tf(j2) + Dy(i) * b3
                            End If
                            j3 = NPrefer(k + 3)
                            If j3 > 0 Then
                                Tf(j3) = Tf(j3) + Dz(i) * b3
                            End If
                        Next i
                    Else
                        For isb = 1 To Nstress
                            For i = 1 To Nvar
                                Db(isb, i) = 0
                                For j = 1 To Nstress
                                    b1 = D(isb, j) * B(j, i)
                                    Db(isb, i) = Db(isb, i) + b1
                                Next j
                            Next i
                            If istage > 0 Then
                                Sgaus(numg, isb) = 0 : kkg = 0
                                For ii = 1 To 20
                                    For id = 1 To Ndim
                                        kkg = kkg + 1
                                        b1 = Db(isb, kkg) * Eu(kkg)
                                        Sgaus(numg, isb) = Sgaus(numg, isb) + b1
                                    Next id
                                Next ii
                            End If
                        Next isb

                        If istage = 0 Then
                            For i = 1 To Nvar
                                For j = i To Nvar
                                    For isb = 1 To Nstress
                                        b1 = B(isb, i) * Db(isb, j) * dv
                                        Ek(i, j) = Ek(i, j) + b1
                                    Next isb
                                Next j
                            Next i
                        Else
                            If KindHSt > 0 Then
                                k = NumMat(ie)
                                b1 = Alpha(k)
                                If KindTemp = 0 Then
                                    b2 = b1 * (TempG(numg) - TempIG(numg))
                                Else
                                    b2 = b1 * (Temp(k) - TempInit(k))
                                End If
                                b3 = D(0, 0) * b2
                                For isb = 1 To 3
                                    Sgaus(numg, isb) = Sgaus(numg, isb) - b3
                                Next isb
                            End If
                        End If
                    End If
                Next kg
            Next jg
        Next ig

    End Sub

    Private Sub CoeffMatrix3(ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        Dim i, ig, isb, j, jg, kg, numg As Integer
        Dim e As Single
        Dim dj, dv, s, t, u As Double
        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                    Call BMatrix()
                    j = ig + 3 * jg + 9 * kg - 12
                    e = Eyb(ie, j)
                    Call DMatrix(ie, e)
                    For isb = 1 To Nstress
                        For i = 1 To Nvar
                            Db(isb, i) = 0
                            For j = 1 To Nstress
                                Db(isb, i) = Db(isb, i) + D(isb, j) * B(j, i)
                            Next j
                        Next i
                    Next isb

                    For i = 1 To Nvar
                        For j = i To Nvar
                            For isb = 1 To Nstress
                                Ek(i, j) = Ek(i, j) + B(isb, i) * Db(isb, j) * dv
                            Next isb
                        Next j
                    Next i
                Next kg
            Next jg
        Next ig

    End Sub

    Private Sub EJoungCalc(ByVal ie As Integer, ByRef ej As Single)
        'ﾔﾝｸﾞ率の計算
        'ie･･･要素番号
        'ej･･･ﾔﾝｸﾞ率
        Dim kmat As Integer
        Dim b1, b2, epsb As Double

        '相当歪みepsbの計算
        b1 = (EpsG(1) - EpsG(2)) ^ 2 + (EpsG(2) - EpsG(3)) ^ 2 + (EpsG(3) - EpsG(1)) ^ 2
        b1 = b1 * 2 / 9
        b2 = (EpsG(4) ^ 2 + EpsG(5) ^ 2 + EpsG(6) ^ 2) / 3
        epsb = Math.Sqrt(b1 + b2)
        If epsb > EpsMax Then
            EpsMax = epsb
        End If

        kmat = NumMat(ie)
        Call StateCalc(kmat, ej, epsb)   '物性状態の計算

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal istage As Integer, _
        ByVal nbase As Integer, ByVal i1 As Integer, _
        ByVal i2 As Integer, ByRef kset As Integer)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･計算区分（-1:初期応力、0:主計算、1:ｶﾞｳｽ点応力）
        'nbase･･･分割行列の変数ﾍﾞｰｽ番号
        'i1,i2･･･分割行列におけ変数の開始番号、終了番号
        'kset･･･対象変数の有無（0:なし、1:有り）
        'jj･･･分割行列の変数の数、対象変数なしの場合は-1を返す
        Dim i, ib, ic, id, ii, j, k, n1, n2, nmax As Integer
        Dim b1 As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            If KindHSt > 0 And KindTemp = 0 Then
                TempE(ii) = Temp(i)
                TempIE(ii) = TempInit(i)
            End If
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = Lcomp(k)
                If KindDPL > 0 Then
                    b1 = Tfx(Lcomp(k))
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + b1
                        Case 2
                            YE(ii) = YE(ii) + b1
                        Case 3
                            ZE(ii) = ZE(ii) + b1
                    End Select
                End If
            Next id
        Next ii
        If istage = 0 And NDmatrix > 1 Then
            kset = 1
            ic = 0
            n1 = nbase + i1
            n2 = nbase + i2
            For i = 1 To Nvar
                ib = NPrefer(i)
                If n1 <= ib And ib <= n2 Then
                    ic = 1
                    Exit For
                End If
            Next i
            If ic = 0 Then
                kset = 0
                Exit Sub
            End If
        End If

        If KindElem = 0 Then
            Call CoeffMatrix(ie, istage)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub ElemMatrix2(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算2
        'ie･･･要素番号
        Dim i, id, ii, j, k, nmax As Integer
        Dim b1 As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = Lcomp(k)
                If KindDPL > 0 Then
                    b1 = Tfx(Lcomp(k))
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + b1
                        Case 2
                            YE(ii) = YE(ii) + b1
                        Case 3
                            ZE(ii) = ZE(ii) + b1
                    End Select
                End If
            Next id
        Next ii

        If KindElem = 0 Then
            Call EpsElem(ie)   '各要素の歪み計算
        End If

    End Sub

    Private Sub ElemMatrix3(ByVal ie As Integer, ByVal zbuf() As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'zbuf()･･･節点変位
        Dim i, id, ii, j, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            For id = 1 To Ndim
                j = j + 1
                If KindDPL > 0 Then
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + zbuf(j)
                        Case 2
                            YE(ii) = YE(ii) + zbuf(j)
                        Case 3
                            ZE(ii) = ZE(ii) + zbuf(j)
                    End Select
                End If
            Next id
        Next ii

        If KindElem = 0 Then
            Call CoeffMatrix3(ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub EpsElem(ByVal ie As Integer)
        '各要素の歪み計算
        'ie･･･要素番号
        Dim i, id, ig, ii, j, jg, kg, kkg, numg As Integer
        Dim ej As Single
        Dim b1, dj, s, t, u As Double
        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    Call BMatrix()
                    For i = 1 To Nstress
                        b1 = 0
                        kkg = 0
                        For ii = 1 To 20
                            For id = 1 To Ndim
                                kkg = kkg + 1
                                b1 = b1 + B(i, kkg) * Eu(kkg)
                            Next id
                        Next ii
                        EpsG(i) = b1
                    Next i
                    Call EJoungCalc(ie, ej) 'ﾔﾝｸﾞ率の計算
                    j = ig + 3 * jg + 9 * kg - 12
                    Eyb(ie, j) = ej
                Next kg
            Next jg
        Next ig

    End Sub

    Private Sub EquaCalc(ByVal cbuf() As Double, ByRef xanswer As Double, _
        ByVal xleft As Double, ByVal xright As Double)
        '主応力の3次方程式の計算（Regular Falsi法）
        'cbuf()･･･係数
        'xanswer･･･方程式の解（最初は初期値）
        'xleft･･･変数区間の下限値
        'xright･･･変数区間の上限値
        Dim iter, itermax As Integer
        Dim b1, epsf, fanswer, fleft, fright As Double
        fanswer = EquaValue(cbuf, xanswer)
        epsf = Math.Abs(fanswer) * 0.000001
        itermax = 100            '繰返し計算の打切り回数
        iter = 0

        Do
            fleft = EquaValue(cbuf, xleft)       'X下限値に対する関数値
            fright = EquaValue(cbuf, xright)     'X上限値に対する関数値

            b1 = fright - fleft
            If b1 = 0 Then
                xanswer = xleft
                Exit Do
            End If
            xanswer = (xleft * fright - xright * fleft) / b1
            fanswer = EquaValue(cbuf, xanswer)

            If fanswer * fright > 0 Then
                xright = xanswer
            Else
                xleft = xanswer
            End If
            iter = iter + 1
        Loop Until Math.Abs(fanswer) < epsf Or iter = itermax

    End Sub

    Private Function EquaValue(ByVal cbuf() As Double, _
        ByVal xb As Double) As Double
        'Xに対する関数値
        'cbuf()･･･係数
        'xb･･･Xの値
        EquaValue = xb ^ 3 + cbuf(2) * xb * xb + cbuf(1) * xb + cbuf(0)

    End Function

    Private Sub FALoadSet(ByVal nx As Integer)
        '座標位置荷重の設定
        'nx･･･変数の数
        Dim aa$
        Dim i, id, j, k, kb, ke, kk, nmax As Integer
        Dim s, t, u, xb, yb, zb As Single

        If KindElem = 0 Then
            nmax = 20
        End If
        Call AxisCheck(1, Nelem, Rlenmax, AxisMax, AxisMin, Xdata, Ydata, Zdata)
        'X、Y、Z軸の最小・最大値のﾁｪｯｸ
        EpsL = Rlenmax * 0.00001

        CInc = 3
        CRed = 0.2
        For i = 1 To NforceA
            xb = XFA(i)
            yb = YFA(i)
            zb = ZFA(i)
            Call ElemFA(ke, s, t, u, xb, yb, zb) '該当要素の検出
            If ke = 0 Then
                aa$ = "座標位置荷重の座標が構造外にあります！"
                MsgBox(aa$, 0, "データエラー")
                Me.Close()
            End If
            For j = 1 To nmax
                kk = NNelem(ke, j)
                kb = Ndim * (Kcomp(kk) - 1)
                For id = 1 To Ndim
                    k = kb + id
                    If Lcomp(k) > 0 And Lcomp(k) <= nx Then
                        Tf(Lcomp(k)) = Tf(Lcomp(k)) + Shape(j) * ForceA(i, id)
                    End If
                Next id
            Next j
        Next i

    End Sub

    Private Sub FLoadSet(ByVal nx As Integer)
        '節点荷重の設定
        'nx･･･変数の数
        Dim i, id, j, kk As Integer
        For i = 1 To Nforce
            kk = KPforce(i)
            j = Ndim * (Kcomp(kk) - 1)
            For id = 1 To Ndim
                j = j + 1
                If Lcomp(j) > 0 And Lcomp(j) <= nx Then
                    Tf(Lcomp(j)) = Force(i, id)
                End If
            Next id
        Next i

    End Sub

    Private Sub GausCalc()
        '積分点物性の計算
        Dim i, id, ie, ii, j, k, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For ie = 1 To Nelem
            j = 0
            For ii = 1 To nmax
                i = NNelem(ie, ii)
                k = Ndim * (Kcomp(i) - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    Eu(j) = Tfx(Lcomp(k))
                Next id
            Next ii
            Call ElemMatrix2(ie)     '要素ﾏﾄﾘｯｸｽの計算2
        Next ie

    End Sub

    Private Sub GLoadSet(ByVal nx As Integer)
        '自重の節点荷重への換算
        'nx･･･変数の数
        Dim i, ie, ig, ii, j, j1, j2, jb, jg As Integer
        Dim k, kb, kg, kgaus, kp, numg, nmax As Integer
        Dim b1, b2, dj, dv, gforce, omega2 As Double
        Dim r1, r2, ratio, rmass As Double
        Dim s, sumdiag, t, totalmass, u As Double
        Dim buf(20) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        If KindRevF > 0 Then    '回転遠心力有りの場合
            kgaus = 1
            b1 = Dpai * RevPS
            omega2 = b1 * b1
        End If

        kb = 0
        For ie = 1 To Nelem
            kp = NumMat(ie)
            If kp <> kb Then
                gforce = DataMat(kp, 3)
                kb = kp
            End If

            For ii = 1 To nmax
                buf(ii) = 0
                i = NNelem(ie, ii)
                XE(ii) = Xdata(i)
                YE(ii) = Ydata(i)
                ZE(ii) = Zdata(i)
                If KindDPL > 0 Then
                    k = Ndim * (Kcomp(i) - 1)
                    XE(ii) = XE(ii) + Tfx(Lcomp(k + 1))
                    YE(ii) = YE(ii) + Tfx(Lcomp(k + 2))
                    ZE(ii) = ZE(ii) + Tfx(Lcomp(k + 3))
                End If
            Next ii

            totalmass = 0   '要素重量合計
            sumdiag = 0     '節点の積分重量合計
            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            numg = numg + 1
                            u = PosGaus(kg)
                            Call ShapeFunc(1, s, t, u)         '形状関数の計算
                            Call JacobElem(ie, kgaus, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            b1 = gforce * dv
                            If KindGrav > 0 Then
                                totalmass = totalmass + b1
                                For i = 1 To 20
                                    b2 = b1 * Shape(i) * Shape(i)
                                    sumdiag = sumdiag + b2
                                    buf(i) = buf(i) + b2
                                Next i
                            End If
                            If KindRevF > 0 Then
                                rmass = b1 / AccGrav
                                Select Case KindRevF
                                    Case 1  'X軸回り
                                        j1 = 2
                                        j2 = 3
                                        r1 = YG(numg)
                                        r2 = ZG(numg)
                                    Case 2  'Y軸回り
                                        j1 = 3
                                        j2 = 1
                                        r1 = ZG(numg)
                                        r2 = XG(numg)
                                    Case 3  'Z軸回り
                                        j1 = 1
                                        j2 = 2
                                        r1 = XG(numg)
                                        r2 = YG(numg)
                                End Select
                                For ii = 1 To 20
                                    b2 = rmass * Shape(ii)
                                    i = NNelem(ie, ii)
                                    j = Ndim * (Kcomp(i) - 1)
                                    jb = j + j1
                                    If Lcomp(jb) > 0 And Lcomp(jb) <= nx Then
                                        Tf(Lcomp(jb)) = Tf(Lcomp(jb)) + b2 * omega2 * r1
                                    End If
                                    jb = j + j2
                                    If Lcomp(jb) > 0 And Lcomp(jb) <= nx Then
                                        Tf(Lcomp(jb)) = Tf(Lcomp(jb)) + b2 * omega2 * r2
                                    End If
                                Next ii
                            End If
                        Next kg
                    Next jg
                Next ig
            End If

            If KindGrav > 0 And sumdiag <> 0 Then
                '要素重量合計の補正・蓄積
                ratio = totalmass / sumdiag
                For ii = 1 To nmax
                    b1 = buf(ii) * ratio
                    i = NNelem(ie, ii)
                    j = Ndim * (Kcomp(i) - 1)
                    For k = 1 To 3
                        j = j + 1
                        b2 = b1 * GravMulti(k)
                        If Lcomp(j) > 0 And Lcomp(j) <= nx Then
                            Tf(Lcomp(j)) = Tf(Lcomp(j)) + b2
                        End If
                    Next k
                Next ii
            End If

        Next ie

    End Sub

    Private Sub HLoadSet(ByVal nx As Integer)
        '分布荷重の節点荷重への換算
        'nx･･･変数の数
        Dim i, ib, id, ie, ii, j, jb, jj, jmax As Integer
        Dim k1, k2, kb, kgp1, kgp2, kind, kk, kmax, nb, nmax, numg As Integer
        Dim b1, da, dj, xb, yb, zb As Double
        Dim kbuf(8) As Integer
        Dim planevec(3), xbuf(3), ybuf(3), zbuf(3) As Single
        Dim gpos(3) As Double

        If KindElem = 0 Then
            jmax = 8
            kmax = 6
            nmax = 20
            nb = 4
        End If
        For ii = 1 To Nsurf
            ie = KPsurf(ii, 1)
            kb = KPsurf(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kb, kind, kbuf, gpos)  '境界条件用の面設定
            End If

            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
                If KindDPL > 0 Then
                    k1 = Ndim * (Kcomp(ib) - 1)
                    XE(j) = XE(j) + Tfx(Lcomp(k1 + 1))
                    YE(j) = YE(j) + Tfx(Lcomp(k1 + 2))
                    ZE(j) = ZE(j) + Tfx(Lcomp(k1 + 3))
                End If
            Next j

            xb = 0 : yb = 0 : zb = 0
            For j = 2 To jmax Step 2
                kb = kbuf(j)
                ib = NNelem(ie, kb)
                xb = xb + Xdata(ib)
                yb = yb + Ydata(ib)
                zb = zb + Zdata(ib)
                Select Case j
                    Case 2
                        xbuf(2) = Xdata(ib)
                        ybuf(2) = Ydata(ib)
                        zbuf(2) = Zdata(ib)
                    Case 4
                        xbuf(3) = Xdata(ib)
                        ybuf(3) = Ydata(ib)
                        zbuf(3) = Zdata(ib)
                End Select
                If KindDPL > 0 Then
                    k1 = Ndim * (Kcomp(ib) - 1)
                    xb = xb + Tfx(Lcomp(k1 + 1))
                    yb = yb + Tfx(Lcomp(k1 + 2))
                    zb = zb + Tfx(Lcomp(k1 + 3))
                    If j = 2 Or j = 4 Then
                        If j = 2 Then
                            k2 = 2
                        Else
                            k2 = 3
                        End If
                        xbuf(k2) = xbuf(k2) + Tfx(Lcomp(k1 + 1))
                        ybuf(k2) = ybuf(k2) + Tfx(Lcomp(k1 + 2))
                        zbuf(k2) = zbuf(k2) + Tfx(Lcomp(k1 + 3))
                    End If
                End If
            Next j
            xbuf(1) = xb / nb
            ybuf(1) = yb / nb
            zbuf(1) = zb / nb

            Call SurfaceVector(planevec, xbuf, ybuf, zbuf)
            '面の法線ﾍﾞｸﾄﾙの計算

            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select
                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            b1 = Pnorm(ii) * Shape(kk) * da
                            jb = Ndim * (j - 1)
                            For id = 1 To 3
                                jb = jb + 1
                                If Lcomp(jb) > 0 And Lcomp(jb) <= nx Then
                                    Tf(Lcomp(jb)) = Tf(Lcomp(jb)) - b1 * planevec(id)
                                End If
                            Next id
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ic, id, ie, j, jmax, jb, k, kb, nb, nex, ngm As Integer
        Dim b1 As Single

        If KindElem = 0 Then
            Nvar = 60
            jmax = 8
            ngm = 27
        End If
        Nstress = 6
        Nall = Ndim * Npoint

        ReDim NPrefer(Nvar), Ek(Nvar, Nvar), B(Nstress, Nvar)
        ReDim Db(Nstress, Nvar)
        ReDim Nw(Npoint), Eu(Nvar)
        ReDim Sgaus(ngm, Nstress), Spoint(20, Nstress)
        ReDim Tp(Npoint, Nstress)
        ReDim Eyb(Nelem, ngm)

        '拘束ﾃﾞｰﾀの処理
        nb = NboundP
        If NboundS > 0 Then
            nb = nb + jmax * NboundS
        End If
        If nb > 0 Then
            Dim nrp(nb), jfix(nb, Ndim) As Integer
            Dim vfix(nb, Ndim) As Single
            k = 0
            If NboundP > 0 Then
                For i = 1 To NboundP
                    k = k + 1
                    nrp(k) = NrestP(i)
                    For id = 1 To Ndim
                        jfix(k, id) = JdirectP(i, id)
                        vfix(k, id) = VdirectP(i, id)
                    Next id
                Next i
            End If
            If NboundS > 0 Then
                Dim kbuf(8) As Integer
                For i = 1 To NboundS
                    ie = KBsurf(i, 1)
                    kb = KBsurf(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = k + 1
                        nrp(k) = kbuf(j)
                        For id = 1 To Ndim
                            jfix(k, id) = JdirectS(i, id)
                            vfix(k, id) = VdirectS(i, id)
                        Next id
                    Next j
                Next i
            End If
            '節点重複の削除･･･最大採用
            For i = 1 To nb
                For j = i + 1 To nb
                    If nrp(i) = nrp(j) Then
                        For id = 1 To Ndim
                            If jfix(j, id) > 0 Then
                                ic = 0
                                If jfix(i, id) = 0 Then
                                    ic = 1
                                ElseIf vfix(j, id) > vfix(i, id) Then
                                    ic = 1
                                End If
                                If ic > 0 Then
                                    jfix(i, id) = 1
                                    vfix(i, id) = vfix(j, id)
                                End If
                            End If
                        Next id
                        nrp(j) = 0
                    End If
                Next j
            Next i
            '拘束条件を新規保存（節点番号順）
            Nbound = 0
            For i = 1 To nb
                If nrp(i) > 0 Then
                    Nbound = Nbound + 1
                End If
            Next i
            ReDim Nrest(Nbound), Jdirect(Nbound, Ndim), Vdirect(Nbound, Ndim)
            For i = 1 To Nbound
                ic = 0
                For j = 1 To nb
                    If nrp(j) > 0 Then
                        If ic = 0 Then
                            k = j
                            ic = 1
                        ElseIf nrp(j) < nrp(k) Then
                            k = j
                        End If
                    End If
                Next j
                Nrest(i) = nrp(k)
                For id = 1 To Ndim
                    Jdirect(i, id) = jfix(k, id)
                    Vdirect(i, id) = vfix(k, id)
                Next id
                nrp(k) = 0
            Next i
        End If

        '変数固定の整理
        Dim nrc(Nbound) As Integer
        NBvar = 0
        For i = 1 To Nbound
            nrc(i) = 1
            For j = 1 To Ndim
                If Jdirect(i, j) <> 0 Then
                    NBvar = NBvar + 1
                End If
            Next j
        Next i
        ReDim KBfix(NBvar), VBfix(NBvar)
        jb = 0
        For i = 1 To Nbound
            ic = 0
            For j = 1 To Nbound
                If nrc(j) > 0 Then
                    If ic = 0 Then
                        k = j
                        kb = Kcomp(Nrest(j))
                        ic = 1
                    ElseIf Kcomp(Nrest(j)) < kb Then
                        k = j
                        kb = Kcomp(Nrest(j))
                    End If
                End If
            Next j
            kb = Ndim * (kb - 1)
            For j = 1 To Ndim
                If Jdirect(k, j) <> 0 Then
                    jb = jb + 1
                    KBfix(jb) = kb + j
                    VBfix(jb) = Vdirect(k, j)
                End If
            Next j
            nrc(k) = 0
        Next i

        '縮小ﾏﾄﾘｯｸｽの設定
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i

        nex = 0
        For i = 1 To NBvar  '0固定の変位変数の除去
            If VBfix(i) = 0 Then
                nex = nex + 1
                Lcomp(KBfix(i)) = 0
            End If
        Next i
        Neff = Nall - nex
        ReDim Tf(Neff), Tfx(Neff)

        j = 0
        For i = 1 To Nall       '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            If Lcomp(i) > 0 Then
                j = j + 1
                Lcomp(i) = j
            End If
        Next i

        'ﾔﾝｸﾞ率の初期設定
        For i = 1 To Nelem
            k = NumMat(i)
            b1 = DataMat(k, 1)
            For j = 1 To ngm
                Eyb(i, j) = b1
            Next j
        Next i

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

    End Sub

    Private Sub InitStrain()
        '初期応力の荷重換算
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim icount, ie, j, kb As Integer
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "初期応力の荷重計算  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        kb = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            j = 0
            Call ElemMatrix(ie, -1, 0, 0, 0, j) '要素ﾏﾄﾘｯｸｽの計算
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        gr.Dispose()

    End Sub

    Private Sub LoadSet()
        '荷重の設定
        If Nforce > 0 Then
            Call FLoadSet(Neff) '節点荷重の設定
        End If

        If NforceA > 0 Then
            Call FALoadSet(Neff) '座標位置荷重の設定
        End If

        If Nsurf > 0 Then
            Call HLoadSet(Neff) '分布荷重の節点荷重への換算
        End If

        If KindGrav > 0 Or KindRevF > 0 Then
            Call GLoadSet(Neff) '自重の節点荷重への換算
        End If

    End Sub

    Private Sub LoadSet2(ByVal nx As Integer)
        '荷重の設定
        'nx･･･変数の数
        If Nforce > 0 Then
            Call FLoadSet(nx) '節点荷重の設定
        End If

        If NforceA > 0 Then
            Call FALoadSet(nx) '座標位置荷重の設定
        End If

        If Nsurf > 0 Then
            Call HLoadSet(nx) '分布荷重の節点荷重への換算
        End If

        If KindGrav > 0 Or KindRevF > 0 Then
            Call GLoadSet(nx) '自重の節点荷重への換算
        End If

    End Sub

    Private Sub MatrixCalcD(ByVal istage As Integer, ByVal mh As Integer)
        'ﾏﾄﾘｯｸｽ計算（分割計算）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'istage･･･ｶﾞｳｽ点応力計算の有無（0:なし、1:有り）
        Dim aa$, timn$
        Dim i, i1, i2, icount, ie, ii, j, j1 As Integer
        Dim k, k1, k2, kb, kd, kk, kset As Integer
        Dim nbase, ni1, ni2, nn, nx, nxx As Integer
        Dim count, cmax As Single
        Dim ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Application.DoEvents()
        timn$ = ""
        count = 0
        cmax = NDmatrix * (NDmatrix + 1) / 2
        For kk = NDmatrix To 1 Step -1
            If kk = NDmatrix Then
                nx = Neff
            Else
                nx = NxF * kk
            End If
            For i = 1 To nx
                Tf(i) = 0
            Next i
            Call LoadSet2(nx)  '荷重の設定

            For kd = 1 To kk  'FEM分割行列の計算（境界固定を含む）
                nbase = NxF * (kd - 1)   'ﾍﾞｰｽの変数の数
                If kd = 1 Then
                    i1 = 1
                Else
                    i1 = mh
                End If
                If kd < kk Then     'i2は分割行列の剛性ﾏﾄﾘｯｸｽ計算範囲
                    i2 = NxF + mh - 1
                Else
                    i2 = nx - nbase
                End If
                If kd > 1 Then
                    For i = 1 To mh - 1
                        ii = NxF + i
                        For j = 1 To mh
                            Tk(i, j) = Tk(ii, j)
                        Next j
                    Next i
                End If
                For i = i1 To i2
                    For j = 1 To mh
                        Tk(i, j) = 0
                    Next j
                Next i
                If kd < kk Then     'nxxは分割行列の前進計算範囲
                    nxx = NxF
                Else
                    nxx = i2
                End If

                ni1 = nbase + i1
                ni2 = nbase + i2
                nn = ni2 + mh - 1
                If nn > nx Then
                    nn = nx
                End If

                Application.DoEvents()
                icount = 0
                kb = 0
                For ie = 1 To Nelem
                    aa$ = "要素" + Str$(ie) + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    Call ElemMatrix(ie, istage, nbase, i1, i2, kset)
                    '要素ﾏﾄﾘｯｸｽの計算

                    If kset > 0 Then
                        Call StoreD(mh, nbase, i1, i2)        '全体ﾏﾄﾘｯｸｽへの蓄積A
                    End If
                    If icount < 99 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next ie

                If Nspring > 0 Then
                    Call SpringSetD(mh, nbase, i1, i2)    'バネ支持の設定D（分割行列）
                End If

                For i = 1 To NBvar
                    k = Lcomp(KBfix(i))
                    If ni1 <= k And k <= ni2 Then
                        ub = VBfix(i)
                        For ii = nbase + 1 To nn
                            kb = ii - nbase
                            If ii < k Then
                                j = k - ii + 1
                                If j <= mh Then
                                    Tf(ii) = Tf(ii) - Tk(kb, j) * ub
                                    Tk(kb, j) = 0
                                End If
                            ElseIf ii = k Then
                                For j = 1 To mh
                                    VBmat(i, j) = Tk(kb, j)
                                    If j = 1 Then
                                        Tk(kb, j) = 1
                                    Else
                                        Tk(kb, j) = 0
                                    End If
                                Next j
                                Tf(ii) = ub
                            Else
                                j = ii - k + 1
                                If j <= mh Then
                                    Tf(ii) = Tf(ii) - VBmat(i, j) * ub
                                End If
                            End If
                        Next ii
                    End If
                Next i

                If kk < NDmatrix And kd = kk Then   '既知変数の代入
                    For k = nxx - mh + 2 To nxx
                        j1 = nxx - k + 2
                        For j = j1 To mh
                            kb = nbase + k
                            ii = kb + j - 1
                            Tf(kb) = Tf(kb) - Tk(k, j) * Tf(ii)
                            Tk(k, j) = 0
                        Next j
                    Next k
                End If

                k1 = nbase + 1
                k2 = nbase + nxx
                If kd < kk Then
                    nn = nxx + mh - 1
                Else
                    nn = nxx
                End If
                Call Solver1D(mh, k1, k2, nn) 'ｿﾙﾊﾞｰ1D（前進側）
                Application.DoEvents()

                If KindDPL = 0 Then
                    count = count + 1.0
                    ProgressBar1.Value = 80 * count / cmax
                End If

            Next kd

            nbase = NxF * (kk - 1)   'ﾍﾞｰｽの変数の数
            k1 = nbase + 1
            k2 = nx
            Call Solver2D(mh, k1, k2) 'ｿﾙﾊﾞｰ2D（後退側）
            Application.DoEvents()

        Next kk

        gr.Dispose()


    End Sub

    Private Sub MemorySet(ByVal mb As Integer)
        'ﾒﾓﾘｰ設定
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$
        Dim i, icc, nb As Integer
        Dim b1, freemem, reqmem As Single

        freemem = 1000 * FreeMemoryGet()
        reqmem = 8.0 * Neff * mb * 1.05
        If reqmem < freemem Then
            NDmatrix = 1
        Else
            reqmem = 8.0 * (mb + 10) * (mb + 100)
            If reqmem > freemem Then
                b1 = reqmem / 100000000.0
                reqmem = (Int(b1) + 1) / 10
                aa$ = "バンド幅が大き過ぎるため、配列変数のメモリーが足りません！"
                aa$ = aa$ + Chr(13) + Chr(10) + "バンドマトリックス法で必要な空きメモリー容量は約"
                aa$ = aa$ + Str(reqmem) + "ＧＢです。"
                MsgBox(aa$, 0, "メモリー不足")
                End
            End If
            b1 = freemem / 8 / (mb + 10) - mb
            NDmatrix = CInt(Neff / b1 + 1)
        End If

        'NDmatrix = 2

        If NDmatrix = 1 Then
            ReDim Tk(Neff, mb)
        Else
            ReDim VBmat(NBvar, mb)
            icc = 0
            NxF = Int(Neff / NDmatrix)
            i = Neff Mod NDmatrix
            If i > 0 Then
                NxF = NxF + 1
            End If
            i = Neff - NxF * (NDmatrix - 1)
            If i < mb Then
                icc = 1
            End If
            If icc = 0 Then
                Try
                    ReDim Tk(NxF + mb - 1, mb)
                Catch
                    aa$ = "ＦＥＭ行列の分割メモリーがオーバーしました！"
                    aa$ = aa$ + Chr(13) + Chr(10)
                    aa$ = aa$ + "自動分割の分割数" + LTrim(Str(NDmatrix)) + "では不足です。"
                    MsgBox(aa$, 0, "メモリーエラー")
                    Me.Close()
                    Exit Sub
                End Try
            Else
                nb = Int(Neff / (mb + 1))
                aa$ = "ＦＥＭ行列分割数が大きすぎます！"
                aa$ = aa$ + Chr(13) + Chr(10)
                aa$ = aa$ + "自動分割の分割数" + LTrim(Str(NDmatrix)) + "を"
                aa$ = aa$ + Str$(nb) + "以下にできません。"
                MsgBox(aa$, 0, "計算条件エラー")
                Me.Close()
                Exit Sub
            End If
        End If

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用

        SwK.WriteLine("＜＜３Ｄ非線形弾性解析の計算結果＞＞")
        aa$ = "［FEM3Dデータファイル］" + "," + Fstruct$
        SwK.WriteLine(aa$)
        SwK.WriteLine(Title$)
        aa$ = "［材料データファイル］" + "," + Fmat$
        SwK.WriteLine(aa$)
        SwK.WriteLine(TitleM$)
        If KindHSt > 0 Then
            aa$ = "［熱応力条件データファイル］" + "," + Fhst$
            SwK.WriteLine(aa$)
            SwK.WriteLine(TitleH$)
        End If
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$
        Dim nb, nex As Integer

        If NDmatrix > 1 Then
            aa$ = "ＦＥＭ行列分割数" + "," + Str(NDmatrix)
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊＊ 計算結果（バンドマトリックス法） ＊＊＊")
        aa$ = "計算マトリックスの変数個数、ハーフバンド幅、保存インデックス数"
        SwK.WriteLine(aa$)
        If NDmatrix = 1 Then
            nb = Neff
        Else
            nb = NxF + mb - 1
        End If
        nex = (nb + 1) * (mb + 1)
        aa$ = "   " + Str(Neff) + ",   " + Str(mb) + ",   " + Str(nex)
        SwK.WriteLine(aa$)
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile3(ByVal iconv As Integer, ByVal nk As Integer, _
    ByVal eps As Single)
        '結果ﾌｧｲﾙへの出力3
        'iconv･･･収束有無（0:非収束、1:収束）
        'nk･･･計算回数
        'eps･･･誤差率
        Dim aa$
        Dim i, id, ip As Integer
        Dim zbuf(3) As Single

        If KindDPL > 0 Then
            SwK.WriteLine("大変形計算を適用")
        End If
        If iconv = 0 Then
            aa$ = "非収束計算回数" + "," + Str(nk)
        Else
            aa$ = "収束計算回数" + "," + Str(nk)
        End If
        SwK.WriteLine(aa$)
        aa$ = "誤差率" + "," + Str(eps)
        SwK.WriteLine(aa$)
        aa$ = "最大の相当歪み" + "," + Str(EpsMax)
        SwK.WriteLine(aa$)
        CalcRes$ = aa$ + Str(EpsMax) + Cr$
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 変位の出力 ＊＊")
        SwK.WriteLine("＜節点番号、δX、δY、δZ＞")

        For ip = 1 To Npoint
            i = Ndim * (Kcomp(ip) - 1)
            For id = 1 To 3
                zbuf(id) = Tf(Lcomp(i + id))
                If Math.Abs(zbuf(id)) > Math.Abs(DispMax(id)) Then
                    DispMax(id) = zbuf(id)
                    KDispMax(id) = ip
                End If
            Next id
            aa$ = Str(ip) + ",  " + Str$(zbuf(1)) + ",  " + Str$(zbuf(2))
            aa$ = aa$ + ",  " + Str$(zbuf(3))
            SwK.WriteLine(aa$)
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        aa$ = "注）σmax、σminは正負込みの最大、最小。その他は絶対値の最大。"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、  最大値、        節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 1 To 3
            Select Case i
                Case 1
                    aa$ = "δX"
                Case 2
                    aa$ = "δY"
                Case 3
                    aa$ = "δZ"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(DispMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KDispMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i
        For i = 1 To 10
            Select Case i
                Case 1
                    aa$ = "σx"
                Case 2
                    aa$ = "σy"
                Case 3
                    aa$ = "σz"
                Case 4
                    aa$ = "τxy"
                Case 5
                    aa$ = "τyz"
                Case 6
                    aa$ = "τzx"
                Case 7
                    aa$ = "σmax"
                Case 8
                    aa$ = "σmin"
                Case 9
                    aa$ = "τmax"
                Case 10
                    aa$ = "σmises"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(StMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KStMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
    ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, ka, mx As Integer
        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it + 1
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(it, j) * ub
                End If
                Tk(it, j) = 0
            Next it
        End If
        If k < Neff Then
            mx = mb
            If k + mb - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                If ub <> 0 Then
                    it = k + j - 1
                    Tf(it) = Tf(it) - Tk(k, j) * ub
                End If
                Tk(k, j) = 0
            Next j
        End If
        Tk(k, 1) = 1
        Tf(k) = ub

    End Sub

    Private Sub Solver1(ByVal mb As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, icount, it, j, jt, k, kdiv, mx As Integer
        Dim crate, dn, fw0, fwx, riter, rmesh, rsec1 As Single
        Dim b1 As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        rmesh = 0.8
        dn = Neff / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Dim timenew As Date = Now
        rsec1 = TimeLap(Timst, timenew)
        Application.DoEvents()
        icount = 0
        For k = 1 To Neff - 1
            mx = mb
            If k + mb - 1 > Neff Then
                mx = Neff - k + 1
            End If
            b1 = Tk(k, 1)
            For j = 2 To mx
                Ua(j) = Tk(k, j) / b1
            Next j
            Tf(k) = Tf(k) / b1
            For i = 2 To mx
                b1 = Tk(k, i)
                If b1 <> 0 Then
                    it = i + k - 1
                    For j = i To mx
                        If Ua(j) <> 0 Then
                            jt = j - i + 1
                            Tk(it, jt) = Tk(it, jt) - b1 * Ua(j)
                        End If
                    Next j
                    Tf(it) = Tf(it) - b1 * Tf(k)
                End If
            Next i
            riter = riter - 1
            If riter <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ1  k=" + Str$(k) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                rmesh = rmesh - 0.06
                crate = 1 - rmesh
                fw0 = Fw1
                fwx = rmesh * Fw1 + crate * Fw2
                kdiv = kdiv + 1
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver1D(ByVal mh As Integer, ByVal k1 As Integer, _
    ByVal k2 As Integer, ByVal nn As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1D（前進側）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'k1･･･変数の開始番号（第1行）
        'k2･･･変数の終了番号
        'nn･･･行列の行数
        Dim aa$, timn$
        Dim i, icount, it, j, jt, k, mbf, mx, nxb As Integer
        Dim dn, riter As Single
        Dim b1 As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1D 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        mbf = 2 * mh - 1
        Dim buf(mbf) As Double

        dn = (k2 - k1 + 1) / 10.0 - 0.001
        riter = dn
        Application.DoEvents()
        icount = 0
        For k = 1 To k2 - k1 + 1
            nxb = k + mh - 1
            If nxb > nn Then
                nxb = nn
            End If
            mx = mh
            If k + mh - 1 > Neff Then
                mx = Neff - k + 1
            End If
            b1 = Tk(k, 1)
            For j = 2 To mx
                Ua(j) = Tk(k, j) / b1
            Next j
            Tf(k + k1 - 1) = Tf(k + k1 - 1) / b1
            For i = 2 To mx
                b1 = Tk(k, i)
                If b1 <> 0 Then
                    it = i + k - 1
                    For j = i To mx
                        If Ua(j) <> 0 Then
                            jt = j - i + 1
                            Tk(it, jt) = Tk(it, jt) - b1 * Ua(j)
                        End If
                    Next j
                    Tf(it + k1 - 1) = Tf(it + k1 - 1) - b1 * Tf(k + k1 - 1)
                End If
            Next i

            riter = riter - 1
            If riter <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ1D  k=" + Str$(k) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mb As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim j, jt, k, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        For k = Neff - 1 To 1 Step -1
            s = 0 : mx = mb
            If k + mb - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                s = s + Tk(k, j) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s / Tk(k, 1)
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2D(ByVal mh As Integer, ByVal k1 As Integer, _
    ByVal k2 As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2D（後退側）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'k1･･･変数の開始番号（第1行）
        'k2･･･変数の終了番号
        Dim aa$, timn$
        Dim j, jt, k, kb, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2D 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        For k = k2 To k1 Step -1
            kb = k - k1 + 1
            s = 0 : mx = mh
            If k + mh - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                s = s + Tk(kb, j) * Tf(jt)
            Next j
            Tf(k) = Tf(k) - s / Tk(kb, 1)
        Next k
        gr.Dispose()

    End Sub

    Private Sub SpringSet()
        'バネ支持の設定
        Dim ib, j, jj, k, k1, k2, kb, kx, kz, m As Integer
        Dim b1 As Single
        Dim acos(3), aval1(3), aval2(3), csb(3), fsb(3) As Single
        For ib = 1 To Nspring
            If KPspring(ib, 2) = 0 Then '単独ﾊﾞﾈ
                k = Ndim * (Kcomp(KPspring(ib, 1)) - 1)
                For j = 1 To 3
                    k = k + 1
                    kb = Lcomp(k)
                    If kb > 0 Then
                        Tk(kb, 1) = Tk(kb, 1) - Cspring(ib, j)
                        Tf(kb) = Tf(kb) + Fspring(ib, j)
                    End If
                Next j
            Else  '節点間ﾊﾞﾈ
                k1 = KPspring(ib, 1)
                k2 = KPspring(ib, 2)
                aval1(1) = Xdata(k1)
                aval1(2) = Ydata(k1)
                aval1(3) = Zdata(k1)
                aval2(1) = Xdata(k2)
                aval2(2) = Ydata(k2)
                aval2(3) = Zdata(k2)
                Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
                For j = 1 To 3
                    csb(j) = Cspring(ib, 1) * acos(j)
                    fsb(j) = Fspring(ib, 1) * acos(j)
                Next j
                k1 = Ndim * (Kcomp(k1) - 1)
                k2 = Ndim * (Kcomp(k2) - 1)
                For m = 1 To 2  '節点1と2
                    If m = 1 Then
                        k = k1
                        b1 = 1  '右辺への初期ﾊﾞﾈ力の加算符号
                    Else
                        k = k2
                        b1 = -1
                    End If
                    For j = 1 To 3  'XYZ方向
                        k = k + 1
                        kx = Lcomp(k)
                        If kx > 0 Then
                            Tk(kx, 1) = Tk(kx, 1) - csb(j) * acos(j)
                            Tf(kx) = Tf(kx) + b1 * fsb(j)
                            If j < 3 Then
                                For jj = j + 1 To 3
                                    kb = k + jj - 1
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        Tk(kx, kz - kx + 1) = Tk(kx, kz - kx + 1) - csb(j) * acos(jj)
                                    End If
                                Next jj
                            End If
                            If m = 1 And k1 < k2 Then   '小さい変数番号の側で記憶
                                For jj = 1 To 3
                                    kb = k2 + jj
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        Tk(kx, kz - kx + 1) = Tk(kx, kz - kx + 1) + csb(j) * acos(jj)
                                    End If
                                Next jj
                            ElseIf m = 2 And k2 < k1 Then
                                For jj = 1 To 3
                                    kb = k1 + jj
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        Tk(kz, kx - kz + 1) = Tk(kz, kx - kz + 1) + csb(j) * acos(jj)
                                    End If
                                Next jj
                            End If

                        End If
                    Next j
                Next m
            End If
        Next ib

    End Sub

    Private Sub SpringSetD(ByVal mh As Integer, ByVal nbase As Integer, _
    ByVal i1 As Integer, ByVal i2 As Integer)
        'バネ支持の設定D（分割行列）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nbase･･･分割行列の変数ﾍﾞｰｽ番号
        'i1,i2･･･分割行列におけ変数の開始番号、終了番号
        Dim aa$
        Dim ib, j, k, kx, n1, n2 As Integer
        n1 = nbase + i1
        n2 = nbase + i2
        For ib = 1 To Nspring
            If KPspring(ib, 2) = 0 Then '単独ﾊﾞﾈ
                k = Ndim * (Kcomp(KPspring(ib, 1)) - 1)
                For j = 1 To 3
                    k = k + 1
                    kx = Lcomp(k)
                    If n1 <= kx And kx <= n2 Then
                        Tk(kx - nbase, 1) = Tk(kx - nbase, 1) - Cspring(ib, j)
                        Tf(kx) = Tf(kx) + Fspring(ib, j)
                    End If
                Next j
            Else    '節点間ﾊﾞﾈ
                aa$ = "バンドマトリックス法の分割計算は、節点間バネに対応していません！"
                MsgBox(aa$, 0, "計算中止")
                End
            End If
        Next ib

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, j, jt As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it > jt Then
                            Tk(jt, it - jt + 1) = Tk(jt, it - jt + 1) + Ek(i, j)
                        Else
                            Tk(it, jt - it + 1) = Tk(it, jt - it + 1) + Ek(i, j)
                        End If
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub StoreD(ByVal mh As Integer, ByVal nbase As Integer, _
    ByVal i1 As Integer, ByVal i2 As Integer)
        '全体ﾏﾄﾘｯｸｽへの蓄積（ﾊｰﾌﾊﾞﾝﾄﾞ用、分割計算）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nbase･･･分割行列の変数ﾍﾞｰｽ番号
        'i1,i2･･･分割行列におけ変数の開始番号、終了番号
        Dim i, it, itb, j, jt, km, n1, n2 As Integer
        n1 = nbase + i1
        n2 = nbase + i2
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it > jt Then
                            If n1 <= jt And jt <= n2 Then
                                itb = jt - nbase
                                km = it - jt + 1
                                Tk(itb, km) = Tk(itb, km) + Ek(i, j)
                            End If
                        Else
                            If n1 <= it And it <= n2 Then
                                itb = it - nbase
                                km = jt - it + 1
                                Tk(itb, km) = Tk(itb, km) + Ek(i, j)
                            End If
                        End If
                    End If
                Next j
            End If
        Next i
    End Sub

    Private Sub StressCalc(ByVal mh As Integer)
        '応力計算
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, icount, id, ie, ii, imat, init, ip, isb, istage, j, jmax, k, nmax As Integer
        Dim b1, sx, sy, sz, txy, tyz, tzx As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "応力 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
            Call TrSet(Tr)  '節点応力計算のTr行列の設定
        End If
        istage = 1 : init = 0
        For imat = 1 To Nmat
            If Nmat > 1 Then
                SwK.WriteLine("----------------------------------------------")
                aa$ = "材料番号" + "," + Str(imat)
                SwK.WriteLine(aa$)
            End If
            For ip = 1 To Npoint
                Nw(ip) = 0
                For isb = 1 To Nstress
                    Tp(ip, isb) = 0
                Next isb
            Next ip
            Application.DoEvents()
            icount = 0
            For ie = 1 To Nelem
                If NumMat(ie) = imat Then
                    '        Write #Kfile, "要素番号=", ie
                    j = 0
                    For ii = 1 To nmax
                        i = NNelem(ie, ii)
                        k = Ndim * (Kcomp(i) - 1)
                        For id = 1 To Ndim
                            j = j + 1
                            k = k + 1
                            Eu(j) = Tf(Lcomp(k))
                        Next id
                    Next ii
                    j = 0
                    Call ElemMatrix(ie, istage, 0, 0, 0, j)
                    '要素ﾏﾄﾘｯｸｽの計算

                    For i = 1 To nmax
                        For isb = 1 To Nstress
                            Spoint(i, isb) = 0
                        Next isb
                        For j = 1 To jmax
                            b1 = Tr(i, j)
                            For isb = 1 To Nstress
                                Spoint(i, isb) = Spoint(i, isb) + b1 * Sgaus(j, isb)
                            Next isb
                        Next j
                    Next i

                    For ii = 1 To nmax
                        i = Kcomp(NNelem(ie, ii))
                        Nw(i) = Nw(i) + 1
                        For isb = 1 To Nstress
                            Tp(i, isb) = Tp(i, isb) + Spoint(ii, isb)
                        Next isb
                    Next ii
                End If
                If icount < 99 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ie
            aa$ = "＜節点番号、σx、σy、σz、τxy、τyz、τzx、"
            aa$ = aa$ + "σmax、σmin、τmax、σmises＞"
            SwK.WriteLine("-----------------------------------------------")
            SwK.WriteLine("＊＊ 節点応力の出力 ＊＊")
            SwK.WriteLine(aa$)
            Application.DoEvents()
            icount = 0
            For ii = 1 To Npoint
                ip = Kcomp(ii)
                If Nw(ip) > 0 Then
                    sx = Tp(ip, 1) / Nw(ip)
                    sy = Tp(ip, 2) / Nw(ip)
                    sz = Tp(ip, 3) / Nw(ip)
                    txy = Tp(ip, 4) / Nw(ip)
                    tyz = Tp(ip, 5) / Nw(ip)
                    tzx = Tp(ip, 6) / Nw(ip)
                    Call StressOut(init, ii, sx, sy, sz, txy, tyz, tzx)
                    '応力値の出力
                End If
                If icount < 999 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ii
        Next imat

    End Sub

    Private Sub StressOut(ByRef init As Integer, ByVal ip As Integer, _
    ByVal sx As Double, ByVal sy As Double, ByVal sz As Double, _
    ByVal txy As Double, ByVal tyz As Double, ByVal tzx As Double)
        '応力値の出力
        'init･･･最大値初期設定の有無（0:なし、1:有り）
        'ip･･･節点番号
        'sx,sy,sz･･･σx,σy,σz
        'txy,tyz,tzx･･･τxy,τyz,τzx
        Dim aa$
        Dim k As Integer
        Dim b1, b2, b3, s1, s2, sb, smax, smin As Double
        Dim x1, x2, xb, xleft, xright As Double
        Dim zbuf(10) As Single
        Dim cbuf(2) As Double

        zbuf(1) = sx
        zbuf(2) = sy
        zbuf(3) = sz
        zbuf(4) = txy
        zbuf(5) = tyz
        zbuf(6) = tzx

        cbuf(2) = -(sx + sy + sz)
        b1 = sx * sy + sy * sz + sz * sx
        b2 = txy * txy + tyz * tyz + tzx * tzx
        cbuf(1) = b1 - b2
        b1 = sx * sy * sz
        b2 = sx * tyz * tyz + sy * tzx * tzx + sz * txy * txy
        b3 = 2 * txy * tyz * tzx
        cbuf(0) = -(b1 - b2 + b3)
        b1 = cbuf(2) ^ 2 - 3 * cbuf(1)
        b2 = Math.Sqrt(b1)
        x1 = (-cbuf(2) - b2) / 3    '下側の極大点
        x2 = (-cbuf(2) + b2) / 3    '上側の極小点
        smax = sx : smin = sx
        For k = 1 To 5
            Select Case k
                Case 1
                    sb = sy
                Case 2
                    sb = sz
                Case 3
                    sb = txy
                Case 4
                    sb = tyz
                Case 5
                    sb = tzx
            End Select
            If sb > smax Then
                smax = sb
            ElseIf sb < smin Then
                smin = sb
            End If
            If k = 2 Then
                s1 = smin
                s2 = smax
            End If
        Next k
        b1 = smax - smin
        xb = x2
        xleft = x2
        xright = x2 + b1
        Call EquaCalc(cbuf, xb, xleft, xright) '3次方程式の計算
        zbuf(7) = xb
        xb = x1
        xleft = x1 - b1
        xright = x1
        Call EquaCalc(cbuf, xb, xleft, xright) '3次方程式の計算
        zbuf(8) = xb
        zbuf(9) = 0.5 * (zbuf(7) - zbuf(8))

        'ﾐｰｾﾞｽ応力の計算
        b1 = 0.5 * ((sx - sy) ^ 2 + (sy - sz) ^ 2 + (sz - sx) ^ 2)
        b1 = b1 + 3 * (txy ^ 2 + tyz ^ 2 + tzx ^ 2)
        zbuf(10) = Math.Sqrt(b1)

        aa$ = Str(ip)
        For k = 1 To 10
            aa$ = aa$ + ",  " + Str(zbuf(k))
        Next k
        SwK.WriteLine(aa$)

        For k = 1 To 10
            Select Case k
                Case 7
                    If init = 0 Or zbuf(7) > StMax(7) Then
                        StMax(7) = zbuf(7)
                        KStMax(7) = ip
                    End If
                Case 8
                    If init = 0 Or zbuf(8) < StMax(8) Then
                        StMax(8) = zbuf(8)
                        KStMax(8) = ip
                        init = 1
                    End If
                Case Else
                    If Math.Abs(zbuf(k)) > Math.Abs(StMax(k)) Then
                        StMax(k) = zbuf(k)
                        KStMax(k) = ip
                    End If
            End Select
        Next k

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub FEM3NLCal4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, iconv, icount, ie, ik, istage As Integer
        Dim j, k, kb, mb, mbx, nk As Integer
        Dim b1, drmesh, eps, freemem, fwx, rmesh, sec As Single
        Dim df, fmax, ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定

        ReDim Ua(mb)
        Call MemorySet(mb)   'ﾒﾓﾘｰ設定

        Call ResFile2(mb)   '結果ﾌｧｲﾙへの出力2
        If NDmatrix > 1 Then
            Label2.Text = "分割計算を実施しています。"
        End If

        rmesh = 0
        drmesh = 0.8 / NKmax
        For ik = 1 To NKmax
            If KindHSt > 0 Then
                Call InitStrain()   '初期応力の計算
            End If

            istage = 0 : kb = 0
            If NDmatrix = 1 Then
                Call LoadSet()  '荷重の設定
                Application.DoEvents()
                icount = 0
                For ie = 1 To Nelem
                    aa$ = "要素" + Str$(ie) + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    j = 0
                    Call ElemMatrix(ie, istage, 0, 0, 0, j)
                    '要素ﾏﾄﾘｯｸｽの計算

                    Call Store()    '全体ﾏﾄﾘｯｸｽへの蓄積
                    If icount < 99 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next ie

                If Nspring > 0 Then
                    Call SpringSet()    'バネ支持の設定
                End If

                '進行表示
                rmesh = rmesh + 0.2 * drmesh
                fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
                ProgressBar1.Value = 100 * fwx / Fw2

                For i = 1 To NBvar
                    k = Lcomp(KBfix(i))
                    If k > 0 Then
                        ub = VBfix(i)
                        Call RestCond(k, mb, ub)    '拘束条件処理
                    End If
                Next i

                Call Solver1(mb)
                'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）

                Tf(Neff) = Tf(Neff) / Tk(Neff, 1)

                Application.DoEvents()
                Call Solver2(mb)    'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
            Else
                Call MatrixCalcD(istage, mb)   'ﾏﾄﾘｯｸｽ計算（分割計算）
                rmesh = rmesh + 0.2 * drmesh
            End If

            '進行表示
            rmesh = rmesh + 0.8 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2
            Dim timenew1 As Date = Now
            sec = TimeLap(Timst, timenew1)
            b1 = 1 - rmesh
            Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算

            Application.DoEvents()
            If NKmax > 1 Then
                df = 0 : fmax = 0
                For j = 1 To Neff
                    ub = Math.Abs(Tf(j) - Tfx(j))
                    If ub > df Then
                        df = ub
                    End If
                    ub = Math.Abs(Tfx(j))
                    If ub > fmax Then
                        fmax = ub
                    End If
                    Tfx(j) = Tf(j)
                Next j
                If ik > 1 Then
                    eps = df / fmax
                    If eps < EpsCalc Then
                        iconv = 1
                        nk = ik
                        Exit For
                    End If
                End If
                If ik = NKmax Then
                    nk = ik
                    Exit For
                Else
                    If NDmatrix = 1 Then
                        For i = 1 To Neff
                            For j = 1 To mb
                                Tk(i, j) = 0
                            Next j
                            Tf(i) = 0
                        Next i
                    Else
                        For i = 1 To NBvar
                            For j = 1 To mb
                                VBmat(i, j) = 0
                            Next j
                        Next i
                    End If
                End If
            Else
                iconv = 1
                Exit For
            End If
            Call GausCalc()     '積分点物性の計算
        Next ik

        If iconv = 0 Then
            aa$ = "計算が収束しませんでした！"
            aa$ = aa$ + Chr(13) + Chr(10) + "繰返し計算回数" + Str$(nk)
            MsgBox(aa$, 0, "計算エラー")
        Else
            Call ResFile3(iconv, nk, eps)   '結果ﾌｧｲﾙへの出力3

            Application.DoEvents()
            Call StressCalc(mb) '応力計算

            Application.DoEvents()
            Call BForceCalc()   '拘束境界の反力計算

            Application.DoEvents()
            Call ResFile4()     '結果ﾌｧｲﾙへの出力4

            '進行表示
            ProgressBar1.Value = 100

            Call TimCal(1, timn$)
            freemem = Int(FreeMemoryGet() / 1000.0)
            aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
            SwK.WriteLine(aa$)
            SwK.Close()

            Label1.Text = "計算終了！"
            Label2.Text = "計算結果をファイルへ出力しました。"
            Label3.Text = aa$
            aa$ = "計算が終了しました。"
            aa$ = aa$ + Chr(13) + Chr(10) + "繰返し計算回数" + Str$(nk)
            aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
            MsgBox(aa$, 0, "計算確認")
        End If

        gr.Dispose()

        Me.Close()

    End Sub
End Class
